<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PenerimaanbarangioService;
use App\Http\Validators\PenerimaanbarangioValidator;
use App\Http\Services\LokasiitemService;
use App\Http\Services\KapalService;
// use App\Http\Services\UsersService; 
use App\Http\Services\PopenerimaanioService;
use App\Http\Services\ItempenerimaanbarangioService;
use App\Http\Services\ItempopenerimaanioService;
use App\Http\Services\StokkapalService;
use App\Http\Services\VoyagesService;
use App\Http\Services\ActivitylogService;
use PDF;

class PenerimaanbarangioController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $lokasiitem;
    private $kapal;
    // private $users; 
    private $popenerimaanio;
    private $itempenerimaanbarangio;
    private $itempopenerimaanio;
    private $stokkapal;
    private $voyage;
    private $activityLog;

    /**
     * Penerimaanbarangio constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new PenerimaanbarangioService();
        $this->validator = new PenerimaanbarangioValidator();
        $this->lokasiitem = new LokasiitemService();
        $this->kapal = new KapalService();

        // $this->users = new UsersService(); */

        $this->popenerimaanio = new PopenerimaanioService();
        $this->itempenerimaanbarangio = new ItempenerimaanbarangioService();
        $this->itempopenerimaanio = new ItempopenerimaanioService();
        $this->stokkapal = new StokkapalService();
        $this->voyage = new VoyagesService();
        $this->activityLog = new ActivitylogService();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $input = $request->all();
        $this->validator->beforeInsert($input);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $auth = json_decode($request->session()->get('auth'));

            // $input["rcNumber"] = $this->baseService->getLastestID("RC" . date("y") . $auth->orgId);
            $input["date"] = date("Y-m-d H:i:s");
            $input["username"] = $auth->username;
            $input["activity"] = "CREATE";
            $input["urlTransaksi"] = "penerimaanbarangio";
            $input["namaTransaksi"] = "Penerimaan Barang IO";
            $input["refId"] = $input["rcNumber"] = $this->baseService->getLastestID("RC" . date("y") . $auth->orgId);

            $ID = $this->baseService->store($input);
            $this->itempenerimaanbarangio->store($input);

            $data = $this->baseService->getPrepareUpdateStock($input);
            $this->stokkapal->updateStock($data);

            $this->itempopenerimaanio->updateQtyRemaining($input);


            $input["deskripsi"] = $auth->name . " just <b>created</b> new Penerimaan Barang IO <a href=\"" . url("administrator/penerimaanbarangio/" . $ID) . "\">" . $input["rcNumber"] . "</a>";
            $this->activityLog->store($input);

            $this->baseService->saveStaging($input);

            DB::commit();

            $nOpenItems = $this->itempopenerimaanio->getStatusItems($input["ioNumber"]);
            if ($nOpenItems > 0) {
                $this->popenerimaanio->updateStatusPO(0, $input);
            } else {
                $this->popenerimaanio->updateStatusPO(1, $input);
            }

            $this->sync();
            return redirect()->to("administrator/popenerimaanio/" . $input["rcID"])->with("successMessages", "Data sudah berhasil disimpan dengan No #" . $input["refId"]);
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = [
            "ioNumber" => "ioNumber", "kapalId" => "kapalId", "locationId" => "locationId", "userId" => "userId", "rcNumber" => "rcNumber", "receiptDate" => "receiptDate"
        ];
        $this->data["criteria"] = [
            "ioNumber" => "ioNumber", "kapalId" => "kapalId", "locationId" => "locationId", "userId" => "userId", "rcNumber" => "rcNumber", "receiptDate" => "receiptDate"
        ];
        $this->data["ordering"] = [
            "ioNumber:asc" => "ioNumber", "kapalId:asc" => "kapalId", "locationId:asc" => "locationId", "userId:asc" => "userId", "rcNumber:asc" => "rcNumber", "receiptDate:asc" => "receiptDate"
        ];
        $this->data["penerimaanbarangios"] = $this->baseService->paging($request);
        return view("modules.penerimaanbarangio.penerimaanbarangio_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["penerimaanbarangio"] = $this->baseService->show($id);
        return view("modules.penerimaanbarangio.penerimaanbarangio_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/penerimaanbarangio")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Request $request, $id)
    {
        $this->data["criteria"] = [
            "deskripsi"     => "Deskripsi",
            "part_number"    => "Part Number",
            "namaItem"      => "Kode Item"
        ];
        $this->data["ioNumber"] = $id;
        $this->data["popenerimaanio"] = $this->popenerimaanio->show($id);
        $this->data["lokasiitems"] = $this->lokasiitem->index($request);
        // $this->data["voyages"] = $this->voyage->index();
        return view("modules.penerimaanbarangio.penerimaanbarangio_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {
        $this->data["penerimaanbarangio"] = $this->baseService->show($id);
        if ($this->data["penerimaanbarangio"]) {
            $this->data["popenerimaanio"] = $this->popenerimaanio->showBasedOnIONumber($request, $this->data["penerimaanbarangio"]);
            $this->data["listItems"] = $this->itempenerimaanbarangio->showBasedOnPenerimaanbarangio($request, $this->data["penerimaanbarangio"]);
            return view("modules.penerimaanbarangio.penerimaanbarangio_show", $this->data);
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    public function search(Request $request)
    {
        $data = $this->itempopenerimaanio->paging($request);
        echo json_encode($data);
    }

    public function reportBarangMasuk(Request $request, $ID)
    {

        PDF::SetTitle('Laporan Barang I/O Masuk');
        PDF::AddPage();
        $data['totalPageCount'] = PDF::getAliasNbPages();
        $data["penerimaanbarang"] = $this->baseService->show($ID);
        if ($data["penerimaanbarang"]) {
            $data["kapal"] = $this->kapal->show($data["penerimaanbarang"]->kapalId);
            $data["popenerimaan"] = $this->popenerimaanio->showBasedOnIONumber($request, $data["penerimaanbarang"]);
            $data["listItems"] = $this->itempenerimaanbarangio->showBasedOnPenerimaanbarangio($request, $data["penerimaanbarang"]);

            $view = \View::make("modules.penerimaanbarang.penerimaan-pdf", $data);
            $htmlContent = $view->render();
            PDF::writeHTML($htmlContent, true, false, true, false . "");
            PDF::Output('laporanbarangmasukio.pdf');
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }
}
